Index: trunk/src/VBox/VMM/PATM/CSAM.cpp
===================================================================
--- trunk/src/VBox/VMM/PATM/CSAM.cpp	(revision 3019)
+++ trunk/src/VBox/VMM/PATM/CSAM.cpp	(revision 3020)
@@ -552,8 +552,8 @@
  *
  */
-static HCPTRTYPE(void *) CSAMGCVirtToHCVirt(PVM pVM, PCSAMP2GLOOKUPREC pCacheRec, GCPTRTYPE(uint8_t *)pGCPtr)
+static HCPTRTYPE(void *) CSAMGCVirtToHCVirt(PVM pVM, PCSAMP2GLOOKUPREC pCacheRec, GCPTRTYPE(uint8_t *) pGCPtr)
 {
     int rc;
-    HCPTRTYPE(void *)pHCPtr;
+    HCPTRTYPE(void *) pHCPtr;
 
     STAM_PROFILE_START(&pVM->csam.s.StatTimeAddrConv, a);
@@ -1076,5 +1076,5 @@
     int rc = VWRN_CONTINUE_ANALYSIS;
     uint32_t opsize;
-    HCPTRTYPE(uint8_t *)pCurInstrHC = 0;
+    HCPTRTYPE(uint8_t *) pCurInstrHC = 0;
     bool disret;
 
Index: trunk/src/VBox/VMM/PATM/PATM.cpp
===================================================================
--- trunk/src/VBox/VMM/PATM/PATM.cpp	(revision 3019)
+++ trunk/src/VBox/VMM/PATM/PATM.cpp	(revision 3020)
@@ -977,8 +977,8 @@
  *
  */
-HCPTRTYPE(uint8_t *) PATMGCVirtToHCVirt(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pGCPtr)
+HCPTRTYPE(uint8_t *) PATMGCVirtToHCVirt(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pGCPtr)
 {
     int rc;
-    HCPTRTYPE(uint8_t *)pHCPtr;
+    HCPTRTYPE(uint8_t *) pHCPtr;
     uint32_t offset;
 
@@ -1028,6 +1028,6 @@
     while (true)
     {
-        GCPTRTYPE(uint8_t *)pInstrGC;
-        GCPTRTYPE(uint8_t *)pBranchTargetGC = 0;
+        GCPTRTYPE(uint8_t *) pInstrGC;
+        GCPTRTYPE(uint8_t *) pBranchTargetGC = 0;
 
         pRec = (PJUMPREC)RTAvlPVRemoveBestFit(&pPatch->JumpTree, 0, true);
@@ -1605,5 +1605,5 @@
         && (OP_PARM_VTYPE(pCpu->pCurInstr->param1) == OP_PARM_J))
     {
-        GCPTRTYPE(uint8_t *)pTargetGC = PATMResolveBranch(pCpu, pCurInstrGC);
+        GCPTRTYPE(uint8_t *) pTargetGC = PATMResolveBranch(pCpu, pCurInstrGC);
         if (pTargetGC == 0)
         {
@@ -2085,5 +2085,5 @@
     int rc = VWRN_CONTINUE_ANALYSIS;
     uint32_t opsize, delta;
-    HCPTRTYPE(uint8_t *)pCurInstrHC = 0;
+    HCPTRTYPE(uint8_t *) pCurInstrHC = 0;
     bool disret;
     char szOutput[256];
@@ -2256,5 +2256,5 @@
     int rc = VWRN_CONTINUE_ANALYSIS;
     uint32_t opsize;
-    HCPTRTYPE(uint8_t *)pCurInstrHC = 0;
+    HCPTRTYPE(uint8_t *) pCurInstrHC = 0;
     bool disret;
 #ifdef LOG_ENABLED
@@ -2368,5 +2368,5 @@
            )
         {
-            GCPTRTYPE(uint8_t *)addr = PATMResolveBranch(&cpu, pCurInstrGC);
+            GCPTRTYPE(uint8_t *) addr = PATMResolveBranch(&cpu, pCurInstrGC);
             if (addr == 0)
             {
@@ -5627,5 +5627,5 @@
  *
  */
-PATMR3DECL(RTGCPTR) PATMR3GuestGCPtrToPatchGCPtr(PVM pVM, GCPTRTYPE(uint8_t*)pInstrGC)
+PATMR3DECL(RTGCPTR) PATMR3GuestGCPtrToPatchGCPtr(PVM pVM, GCPTRTYPE(uint8_t*) pInstrGC)
 {
     PPATMPATCHREC pPatchRec = (PPATMPATCHREC)RTAvloGCPtrGetBestFit(&pVM->patm.s.PatchLookupTreeHC->PatchTree, pInstrGC, false);
Index: trunk/src/VBox/VMM/PATM/PATMInternal.h
===================================================================
--- trunk/src/VBox/VMM/PATM/PATMInternal.h	(revision 3019)
+++ trunk/src/VBox/VMM/PATM/PATMInternal.h	(revision 3020)
@@ -135,5 +135,5 @@
 
     uint32_t        uType;
-    HCPTRTYPE(uint8_t *)pRelocPos;
+    HCPTRTYPE(uint8_t *) pRelocPos;
     RTGCPTR         pSource;
     RTGCPTR         pDest;
@@ -153,6 +153,6 @@
     AVLPVNODECORE   Core;
 
-    HCPTRTYPE(uint8_t *)pJumpHC;
-    GCPTRTYPE(uint8_t *)pTargetGC;
+    HCPTRTYPE(uint8_t *) pJumpHC;
+    GCPTRTYPE(uint8_t *) pTargetGC;
     uint32_t            offDispl;
     uint32_t            opcode;
@@ -327,5 +327,5 @@
     uint32_t           cMaxPatches;
     /** Array of patch pointers for this page. */
-    HCPTRTYPE(PPATCHINFO *)aPatch;
+    HCPTRTYPE(PPATCHINFO *) aPatch;
 } PATMPATCHPAGE, *PPATMPATCHPAGE;
 
@@ -527,5 +527,5 @@
 #ifdef IN_RING3
 RTGCPTR patmPatchGCPtr2GuestGCPtr(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pPatchGC);
-RTGCPTR patmGuestGCPtrToPatchGCPtr(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t*)pInstrGC);
+RTGCPTR patmGuestGCPtrToPatchGCPtr(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t*) pInstrGC);
 #endif
 
@@ -616,5 +616,5 @@
  *
  */
-HCPTRTYPE(uint8_t *) PATMGCVirtToHCVirt(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pGCPtr);
+HCPTRTYPE(uint8_t *) PATMGCVirtToHCVirt(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pGCPtr);
 
 
@@ -656,5 +656,5 @@
  * @param   fPatchFlags Patch flags
  */
-PATMDECL(const char *)patmGetInstructionString(uint32_t opcode, uint32_t fPatchFlags);
+PATMDECL(const char *) patmGetInstructionString(uint32_t opcode, uint32_t fPatchFlags);
 
 
Index: trunk/src/VBox/VMM/PATM/PATMPatch.cpp
===================================================================
--- trunk/src/VBox/VMM/PATM/PATMPatch.cpp	(revision 3019)
+++ trunk/src/VBox/VMM/PATM/PATMPatch.cpp	(revision 3020)
@@ -128,5 +128,5 @@
 
 
-static uint32_t patmPatchGenCode(PVM pVM, PPATCHINFO pPatch, uint8_t *pPB, PPATCHASMRECORD pAsmRecord, GCPTRTYPE(uint8_t *)pReturnAddrGC, bool fGenJump,
+static uint32_t patmPatchGenCode(PVM pVM, PPATCHINFO pPatch, uint8_t *pPB, PPATCHASMRECORD pAsmRecord, GCPTRTYPE(uint8_t *) pReturnAddrGC, bool fGenJump,
                                  PPATMCALLINFO pCallInfo = 0)
 {
@@ -147,5 +147,5 @@
             if (*(uint32_t*)&pPB[j] == pAsmRecord->uReloc[i])
             {
-                GCPTRTYPE(uint32_t *)dest;
+                GCPTRTYPE(uint32_t *) dest;
 
 #ifdef VBOX_STRICT
@@ -464,5 +464,5 @@
 
 
-int patmPatchGenPopf(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pReturnAddrGC, bool fSizeOverride, bool fGenJumpBack)
+int patmPatchGenPopf(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pReturnAddrGC, bool fSizeOverride, bool fGenJumpBack)
 {
     uint32_t        size;
@@ -519,5 +519,5 @@
 }
 
-int patmPatchGenLoop(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pTargetGC, uint32_t opcode, bool fSizeOverride)
+int patmPatchGenLoop(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pTargetGC, uint32_t opcode, bool fSizeOverride)
 {
     uint32_t size = 0;
@@ -564,5 +564,5 @@
 }
 
-int patmPatchGenRelJump(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pTargetGC, uint32_t opcode, bool fSizeOverride)
+int patmPatchGenRelJump(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pTargetGC, uint32_t opcode, bool fSizeOverride)
 {
     uint32_t offset = 0;
@@ -1547,5 +1547,5 @@
  * @param   fClearInhibitIRQs   Clear inhibit irq flag
  */
-int patmPatchGenJumpToGuest(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pReturnAddrGC, bool fClearInhibitIRQs)
+int patmPatchGenJumpToGuest(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pReturnAddrGC, bool fClearInhibitIRQs)
 {
     int rc = VINF_SUCCESS;
@@ -1575,5 +1575,5 @@
  * Relative jump from patch code to patch code (no fixup required)
  */
-int patmPatchGenPatchJump(PVM pVM, PPATCHINFO pPatch, RTGCPTR pCurInstrGC, GCPTRTYPE(uint8_t *)pPatchAddrGC, bool fAddLookupRecord)
+int patmPatchGenPatchJump(PVM pVM, PPATCHINFO pPatch, RTGCPTR pCurInstrGC, GCPTRTYPE(uint8_t *) pPatchAddrGC, bool fAddLookupRecord)
 {
     int32_t displ;
Index: trunk/src/VBox/VMM/PATM/PATMPatch.h
===================================================================
--- trunk/src/VBox/VMM/PATM/PATMPatch.h	(revision 3019)
+++ trunk/src/VBox/VMM/PATM/PATMPatch.h	(revision 3020)
@@ -31,8 +31,8 @@
 int patmPatchGenMovDebug(PVM pVM, PPATCHINFO pPatch, DISCPUSTATE *pCpu);
 int patmPatchGenMovFromSS(PVM pVM, PPATCHINFO pPatch, DISCPUSTATE *pCpu, RTGCPTR pCurInstrGC);
-int patmPatchGenRelJump(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pTargetGC, uint32_t opcode, bool fSizeOverride);
-int patmPatchGenLoop(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pTargetGC, uint32_t opcode, bool fSizeOverride);
+int patmPatchGenRelJump(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pTargetGC, uint32_t opcode, bool fSizeOverride);
+int patmPatchGenLoop(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pTargetGC, uint32_t opcode, bool fSizeOverride);
 int patmPatchGenPushf(PVM pVM, PPATCHINFO pPatch, bool fSizeOverride);
-int patmPatchGenPopf(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pReturnAddrGC, bool fSizeOverride, bool fGenJumpBack);
+int patmPatchGenPopf(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pReturnAddrGC, bool fSizeOverride, bool fGenJumpBack);
 int patmPatchGenSti(PVM pVM, PPATCHINFO pPatch, RTGCPTR pCurInstrGC, RTGCPTR pNextInstrGC);
 
@@ -47,5 +47,5 @@
 int patmPatchGenRet(PVM pVM, PPATCHINFO pPatch, DISCPUSTATE *pCpu, GCPTRTYPE(uint8_t *) pCurInstrGC);
 
-int patmPatchGenPatchJump(PVM pVM, PPATCHINFO pPatch, RTGCPTR pCurInstrGC, GCPTRTYPE(uint8_t *)pPatchAddrGC, bool fAddLookupRecord = true);
+int patmPatchGenPatchJump(PVM pVM, PPATCHINFO pPatch, RTGCPTR pCurInstrGC, GCPTRTYPE(uint8_t *) pPatchAddrGC, bool fAddLookupRecord = true);
 
 /**
@@ -89,5 +89,5 @@
  * @param   fClearInhibitIRQs   Clear inhibit irq flag
  */
-int patmPatchGenJumpToGuest(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *)pReturnAddrGC, bool fClearInhibitIRQs = false);
+int patmPatchGenJumpToGuest(PVM pVM, PPATCHINFO pPatch, GCPTRTYPE(uint8_t *) pReturnAddrGC, bool fClearInhibitIRQs = false);
 
 /**
Index: trunk/src/VBox/VMM/PATM/VMMAll/PATMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/PATM/VMMAll/PATMAll.cpp	(revision 3019)
+++ trunk/src/VBox/VMM/PATM/VMMAll/PATMAll.cpp	(revision 3020)
@@ -530,5 +530,5 @@
  * @param   fPatchFlags Patch flags
  */
-PATMDECL(const char *)patmGetInstructionString(uint32_t opcode, uint32_t fPatchFlags)
+PATMDECL(const char *) patmGetInstructionString(uint32_t opcode, uint32_t fPatchFlags)
 {
     const char *pszInstr = NULL;