Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 3128)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 3129)
@@ -134,5 +134,5 @@
         <item>
             <property name="text">
-                <string> Floppy </string>
+                <string> CD/DVD-ROM </string>
             </property>
             <property name="text">
@@ -140,8 +140,8 @@
             </property>
             <property name="text">
-                <string>#floppy</string>
+                <string>#dvd</string>
             </property>
             <property name="pixmap">
-                <pixmap>fd_16px.png</pixmap>
+                <pixmap>cd_16px.png</pixmap>
             </property>
             <property name="pixmap">
@@ -154,5 +154,5 @@
         <item>
             <property name="text">
-                <string> CD/DVD-ROM </string>
+                <string> Floppy </string>
             </property>
             <property name="text">
@@ -160,8 +160,8 @@
             </property>
             <property name="text">
-                <string>#dvd</string>
+                <string>#floppy</string>
             </property>
             <property name="pixmap">
-                <pixmap>cd_16px.png</pixmap>
+                <pixmap>fd_16px.png</pixmap>
             </property>
             <property name="pixmap">
@@ -1508,4 +1508,179 @@
             <widget class="QWidget">
                 <property name="name">
+                    <cstring>pageDVD</cstring>
+                </property>
+                <attribute name="id">
+                    <number>3</number>
+                </attribute>
+                <vbox>
+                    <property name="name">
+                        <cstring>unnamed</cstring>
+                    </property>
+                    <property name="margin">
+                        <number>0</number>
+                    </property>
+                    <property name="spacing">
+                        <number>10</number>
+                    </property>
+                    <widget class="QButtonGroup">
+                        <property name="name">
+                            <cstring>bgDVD</cstring>
+                        </property>
+                        <property name="title">
+                            <string>&amp;Mount CD/DVD Drive</string>
+                        </property>
+                        <property name="checkable">
+                            <bool>true</bool>
+                        </property>
+                        <vbox>
+                            <property name="name">
+                                <cstring>unnamed</cstring>
+                            </property>
+                            <widget class="QLayoutWidget">
+                                <property name="name">
+                                    <cstring>layout39</cstring>
+                                </property>
+                                <hbox>
+                                    <property name="name">
+                                        <cstring>unnamed</cstring>
+                                    </property>
+                                    <widget class="QRadioButton">
+                                        <property name="name">
+                                            <cstring>rbHostDVD</cstring>
+                                        </property>
+                                        <property name="text">
+                                            <string>Host CD/DVD &amp;Drive</string>
+                                        </property>
+                                        <property name="accel">
+                                            <string>Alt+D</string>
+                                        </property>
+                                        <property name="whatsThis" stdset="0">
+                                            <string>Mounts the specified CD/DVD drive to the virtual CD/DVD drive.</string>
+                                        </property>
+                                    </widget>
+                                    <widget class="QComboBox">
+                                        <property name="name">
+                                            <cstring>cbHostDVD</cstring>
+                                        </property>
+                                        <property name="whatsThis" stdset="0">
+                                            <string>Lists host CD/DVD drives available to mount to the virtual machine.</string>
+                                        </property>
+                                    </widget>
+                                    <spacer>
+                                        <property name="name">
+                                            <cstring>spacer23</cstring>
+                                        </property>
+                                        <property name="orientation">
+                                            <enum>Horizontal</enum>
+                                        </property>
+                                        <property name="sizeType">
+                                            <enum>Expanding</enum>
+                                        </property>
+                                        <property name="sizeHint">
+                                            <size>
+                                                <width>51</width>
+                                                <height>20</height>
+                                            </size>
+                                        </property>
+                                    </spacer>
+                                </hbox>
+                            </widget>
+                            <widget class="QLayoutWidget">
+                                <property name="name">
+                                    <cstring>layout40</cstring>
+                                </property>
+                                <hbox>
+                                    <property name="name">
+                                        <cstring>unnamed</cstring>
+                                    </property>
+                                    <widget class="QRadioButton">
+                                        <property name="name">
+                                            <cstring>rbISODVD</cstring>
+                                        </property>
+                                        <property name="text">
+                                            <string>&amp;ISO Image File</string>
+                                        </property>
+                                        <property name="accel">
+                                            <string>Alt+I</string>
+                                        </property>
+                                        <property name="whatsThis" stdset="0">
+                                            <string>Mounts the specified CD/DVD image to the virtual CD/DVD drive.</string>
+                                        </property>
+                                    </widget>
+                                    <spacer>
+                                        <property name="name">
+                                            <cstring>spacer35_4</cstring>
+                                        </property>
+                                        <property name="orientation">
+                                            <enum>Horizontal</enum>
+                                        </property>
+                                        <property name="sizeType">
+                                            <enum>Expanding</enum>
+                                        </property>
+                                        <property name="sizeHint">
+                                            <size>
+                                                <width>156</width>
+                                                <height>20</height>
+                                            </size>
+                                        </property>
+                                    </spacer>
+                                </hbox>
+                            </widget>
+                            <widget class="QLayoutWidget">
+                                <property name="name">
+                                    <cstring>cdLayout</cstring>
+                                </property>
+                                <hbox>
+                                    <property name="name">
+                                        <cstring>unnamed</cstring>
+                                    </property>
+                                    <widget class="QToolButton">
+                                        <property name="name">
+                                            <cstring>tbISODVD</cstring>
+                                        </property>
+                                        <property name="focusPolicy">
+                                            <enum>TabFocus</enum>
+                                        </property>
+                                        <property name="text">
+                                            <string>Select</string>
+                                        </property>
+                                        <property name="iconSet">
+                                            <iconset></iconset>
+                                        </property>
+                                        <property name="textLabel">
+                                            <string>Select</string>
+                                        </property>
+                                        <property name="autoRaise">
+                                            <bool>true</bool>
+                                        </property>
+                                        <property name="whatsThis" stdset="0">
+                                            <string>Invokes the Virtual Disk Manager to select a CD/DVD image to mount.</string>
+                                        </property>
+                                    </widget>
+                                </hbox>
+                            </widget>
+                        </vbox>
+                    </widget>
+                    <spacer>
+                        <property name="name">
+                            <cstring>spacer19</cstring>
+                        </property>
+                        <property name="orientation">
+                            <enum>Vertical</enum>
+                        </property>
+                        <property name="sizeType">
+                            <enum>Expanding</enum>
+                        </property>
+                        <property name="sizeHint">
+                            <size>
+                                <width>20</width>
+                                <height>0</height>
+                            </size>
+                        </property>
+                    </spacer>
+                </vbox>
+            </widget>
+            <widget class="QWidget">
+                <property name="name">
                     <cstring>pageFloppy</cstring>
                 </property>
@@ -1665,179 +1840,4 @@
                         <property name="name">
                             <cstring>spacer119</cstring>
-                        </property>
-                        <property name="orientation">
-                            <enum>Vertical</enum>
-                        </property>
-                        <property name="sizeType">
-                            <enum>Expanding</enum>
-                        </property>
-                        <property name="sizeHint">
-                            <size>
-                                <width>20</width>
-                                <height>0</height>
-                            </size>
-                        </property>
-                    </spacer>
-                </vbox>
-            </widget>
-            <widget class="QWidget">
-                <property name="name">
-                    <cstring>pageDVD</cstring>
-                </property>
-                <attribute name="id">
-                    <number>3</number>
-                </attribute>
-                <vbox>
-                    <property name="name">
-                        <cstring>unnamed</cstring>
-                    </property>
-                    <property name="margin">
-                        <number>0</number>
-                    </property>
-                    <property name="spacing">
-                        <number>10</number>
-                    </property>
-                    <widget class="QButtonGroup">
-                        <property name="name">
-                            <cstring>bgDVD</cstring>
-                        </property>
-                        <property name="title">
-                            <string>&amp;Mount CD/DVD Drive</string>
-                        </property>
-                        <property name="checkable">
-                            <bool>true</bool>
-                        </property>
-                        <vbox>
-                            <property name="name">
-                                <cstring>unnamed</cstring>
-                            </property>
-                            <widget class="QLayoutWidget">
-                                <property name="name">
-                                    <cstring>layout39</cstring>
-                                </property>
-                                <hbox>
-                                    <property name="name">
-                                        <cstring>unnamed</cstring>
-                                    </property>
-                                    <widget class="QRadioButton">
-                                        <property name="name">
-                                            <cstring>rbHostDVD</cstring>
-                                        </property>
-                                        <property name="text">
-                                            <string>Host CD/DVD &amp;Drive</string>
-                                        </property>
-                                        <property name="accel">
-                                            <string>Alt+D</string>
-                                        </property>
-                                        <property name="whatsThis" stdset="0">
-                                            <string>Mounts the specified CD/DVD drive to the virtual CD/DVD drive.</string>
-                                        </property>
-                                    </widget>
-                                    <widget class="QComboBox">
-                                        <property name="name">
-                                            <cstring>cbHostDVD</cstring>
-                                        </property>
-                                        <property name="whatsThis" stdset="0">
-                                            <string>Lists host CD/DVD drives available to mount to the virtual machine.</string>
-                                        </property>
-                                    </widget>
-                                    <spacer>
-                                        <property name="name">
-                                            <cstring>spacer23</cstring>
-                                        </property>
-                                        <property name="orientation">
-                                            <enum>Horizontal</enum>
-                                        </property>
-                                        <property name="sizeType">
-                                            <enum>Expanding</enum>
-                                        </property>
-                                        <property name="sizeHint">
-                                            <size>
-                                                <width>51</width>
-                                                <height>20</height>
-                                            </size>
-                                        </property>
-                                    </spacer>
-                                </hbox>
-                            </widget>
-                            <widget class="QLayoutWidget">
-                                <property name="name">
-                                    <cstring>layout40</cstring>
-                                </property>
-                                <hbox>
-                                    <property name="name">
-                                        <cstring>unnamed</cstring>
-                                    </property>
-                                    <widget class="QRadioButton">
-                                        <property name="name">
-                                            <cstring>rbISODVD</cstring>
-                                        </property>
-                                        <property name="text">
-                                            <string>&amp;ISO Image File</string>
-                                        </property>
-                                        <property name="accel">
-                                            <string>Alt+I</string>
-                                        </property>
-                                        <property name="whatsThis" stdset="0">
-                                            <string>Mounts the specified CD/DVD image to the virtual CD/DVD drive.</string>
-                                        </property>
-                                    </widget>
-                                    <spacer>
-                                        <property name="name">
-                                            <cstring>spacer35_4</cstring>
-                                        </property>
-                                        <property name="orientation">
-                                            <enum>Horizontal</enum>
-                                        </property>
-                                        <property name="sizeType">
-                                            <enum>Expanding</enum>
-                                        </property>
-                                        <property name="sizeHint">
-                                            <size>
-                                                <width>156</width>
-                                                <height>20</height>
-                                            </size>
-                                        </property>
-                                    </spacer>
-                                </hbox>
-                            </widget>
-                            <widget class="QLayoutWidget">
-                                <property name="name">
-                                    <cstring>cdLayout</cstring>
-                                </property>
-                                <hbox>
-                                    <property name="name">
-                                        <cstring>unnamed</cstring>
-                                    </property>
-                                    <widget class="QToolButton">
-                                        <property name="name">
-                                            <cstring>tbISODVD</cstring>
-                                        </property>
-                                        <property name="focusPolicy">
-                                            <enum>TabFocus</enum>
-                                        </property>
-                                        <property name="text">
-                                            <string>Select</string>
-                                        </property>
-                                        <property name="iconSet">
-                                            <iconset></iconset>
-                                        </property>
-                                        <property name="textLabel">
-                                            <string>Select</string>
-                                        </property>
-                                        <property name="autoRaise">
-                                            <bool>true</bool>
-                                        </property>
-                                        <property name="whatsThis" stdset="0">
-                                            <string>Invokes the Virtual Disk Manager to select a CD/DVD image to mount.</string>
-                                        </property>
-                                    </widget>
-                                </hbox>
-                            </widget>
-                        </vbox>
-                    </widget>
-                    <spacer>
-                        <property name="name">
-                            <cstring>spacer19</cstring>
                         </property>
                         <property name="orientation">
@@ -2838,4 +2838,8 @@
     <tabstop>grbHDD</tabstop>
     <tabstop>tbHDD</tabstop>
+    <tabstop>rbHostDVD</tabstop>
+    <tabstop>cbHostDVD</tabstop>
+    <tabstop>rbISODVD</tabstop>
+    <tabstop>tbISODVD</tabstop>
     <tabstop>bgFloppy</tabstop>
     <tabstop>rbHostFloppy</tabstop>
@@ -2843,8 +2847,4 @@
     <tabstop>rbISOFloppy</tabstop>
     <tabstop>tbISOFloppy</tabstop>
-    <tabstop>rbHostDVD</tabstop>
-    <tabstop>cbHostDVD</tabstop>
-    <tabstop>rbISODVD</tabstop>
-    <tabstop>tbISODVD</tabstop>
     <tabstop>cbAudioDriver</tabstop>
     <tabstop>cbEnableUSBController</tabstop>